// SPDX-License-Identifier: GPL-2.0-or-later
/*
 * Copyright (C) Telechips Inc.
 */

#include <linux/types.h>
#include "tcc_snor_updater_crc8.h"

static const uint32_t CRC32_TABLE[256] = {
	0x00000000U, 0x90910101U, 0x91210201U, 0x01B00300U,
	0x92410401U, 0x02D00500U, 0x03600600U, 0x93F10701U,
	0x94810801U, 0x04100900U, 0x05A00A00U, 0x95310B01U,
	0x06C00C00U, 0x96510D01U, 0x97E10E01U, 0x07700F00U,
	0x99011001U, 0x09901100U, 0x08201200U, 0x98B11301U,
	0x0B401400U, 0x9BD11501U, 0x9A611601U, 0x0AF01700U,
	0x0D801800U, 0x9D111901U, 0x9CA11A01U, 0x0C301B00U,
	0x9FC11C01U, 0x0F501D00U, 0x0EE01E00U, 0x9E711F01U,
	0x82012001U, 0x12902100U, 0x13202200U, 0x83B12301U,
	0x10402400U, 0x80D12501U, 0x81612601U, 0x11F02700U,
	0x16802800U, 0x86112901U, 0x87A12A01U, 0x17302B00U,
	0x84C12C01U, 0x14502D00U, 0x15E02E00U, 0x85712F01U,
	0x1B003000U, 0x8B913101U, 0x8A213201U, 0x1AB03300U,
	0x89413401U, 0x19D03500U, 0x18603600U, 0x88F13701U,
	0x8F813801U, 0x1F103900U, 0x1EA03A00U, 0x8E313B01U,
	0x1DC03C00U, 0x8D513D01U, 0x8CE13E01U, 0x1C703F00U,
	0xB4014001U, 0x24904100U, 0x25204200U, 0xB5B14301U,
	0x26404400U, 0xB6D14501U, 0xB7614601U, 0x27F04700U,
	0x20804800U, 0xB0114901U, 0xB1A14A01U, 0x21304B00U,
	0xB2C14C01U, 0x22504D00U, 0x23E04E00U, 0xB3714F01U,
	0x2D005000U, 0xBD915101U, 0xBC215201U, 0x2CB05300U,
	0xBF415401U, 0x2FD05500U, 0x2E605600U, 0xBEF15701U,
	0xB9815801U, 0x29105900U, 0x28A05A00U, 0xB8315B01U,
	0x2BC05C00U, 0xBB515D01U, 0xBAE15E01U, 0x2A705F00U,
	0x36006000U, 0xA6916101U, 0xA7216201U, 0x37B06300U,
	0xA4416401U, 0x34D06500U, 0x35606600U, 0xA5F16701U,
	0xA2816801U, 0x32106900U, 0x33A06A00U, 0xA3316B01U,
	0x30C06C00U, 0xA0516D01U, 0xA1E16E01U, 0x31706F00U,
	0xAF017001U, 0x3F907100U, 0x3E207200U, 0xAEB17301U,
	0x3D407400U, 0xADD17501U, 0xAC617601U, 0x3CF07700U,
	0x3B807800U, 0xAB117901U, 0xAAA17A01U, 0x3A307B00U,
	0xA9C17C01U, 0x39507D00U, 0x38E07E00U, 0xA8717F01U,
	0xD8018001U, 0x48908100U, 0x49208200U, 0xD9B18301U,
	0x4A408400U, 0xDAD18501U, 0xDB618601U, 0x4BF08700U,
	0x4C808800U, 0xDC118901U, 0xDDA18A01U, 0x4D308B00U,
	0xDEC18C01U, 0x4E508D00U, 0x4FE08E00U, 0xDF718F01U,
	0x41009000U, 0xD1919101U, 0xD0219201U, 0x40B09300U,
	0xD3419401U, 0x43D09500U, 0x42609600U, 0xD2F19701U,
	0xD5819801U, 0x45109900U, 0x44A09A00U, 0xD4319B01U,
	0x47C09C00U, 0xD7519D01U, 0xD6E19E01U, 0x46709F00U,
	0x5A00A000U, 0xCA91A101U, 0xCB21A201U, 0x5BB0A300U,
	0xC841A401U, 0x58D0A500U, 0x5960A600U, 0xC9F1A701U,
	0xCE81A801U, 0x5E10A900U, 0x5FA0AA00U, 0xCF31AB01U,
	0x5CC0AC00U, 0xCC51AD01U, 0xCDE1AE01U, 0x5D70AF00U,
	0xC301B001U, 0x5390B100U, 0x5220B200U, 0xC2B1B301U,
	0x5140B400U, 0xC1D1B501U, 0xC061B601U, 0x50F0B700U,
	0x5780B800U, 0xC711B901U, 0xC6A1BA01U, 0x5630BB00U,
	0xC5C1BC01U, 0x5550BD00U, 0x54E0BE00U, 0xC471BF01U,
	0x6C00C000U, 0xFC91C101U, 0xFD21C201U, 0x6DB0C300U,
	0xFE41C401U, 0x6ED0C500U, 0x6F60C600U, 0xFFF1C701U,
	0xF881C801U, 0x6810C900U, 0x69A0CA00U, 0xF931CB01U,
	0x6AC0CC00U, 0xFA51CD01U, 0xFBE1CE01U, 0x6B70CF00U,
	0xF501D001U, 0x6590D100U, 0x6420D200U, 0xF4B1D301U,
	0x6740D400U, 0xF7D1D501U, 0xF661D601U, 0x66F0D700U,
	0x6180D800U, 0xF111D901U, 0xF0A1DA01U, 0x6030DB00U,
	0xF3C1DC01U, 0x6350DD00U, 0x62E0DE00U, 0xF271DF01U,
	0xEE01E001U, 0x7E90E100U, 0x7F20E200U, 0xEFB1E301U,
	0x7C40E400U, 0xECD1E501U, 0xED61E601U, 0x7DF0E700U,
	0x7A80E800U, 0xEA11E901U, 0xEBA1EA01U, 0x7B30EB00U,
	0xE8C1EC01U, 0x7850ED00U, 0x79E0EE00U, 0xE971EF01U,
	0x7700F000U, 0xE791F101U, 0xE621F201U, 0x76B0F300U,
	0xE541F401U, 0x75D0F500U, 0x7460F600U, 0xE4F1F701U,
	0xE381F801U, 0x7310F900U, 0x72A0FA00U, 0xE231FB01U,
	0x71C0FC00U, 0xE151FD01U, 0xE0E1FE01U, 0x7070FF00U
};

uint32_t tcc_snor_calc_crc8(const u8 *base, uint32_t length)
{
	uint32_t crcout = 0;
	uint32_t cnt;
	u8 code;
	uint32_t tmp;

	for (cnt = 0; cnt < length; cnt++) {
		code = base[cnt];
		tmp = code^crcout;
		crcout = (crcout >> (uint32_t)8) ^ CRC32_TABLE[tmp & (u8)0xFF];
	}

	return crcout;
}

